#include "mainwindow.h"
#include "qmessagebox.h"
#include <QApplication>

#include "Process.h"


bool ReadProtoParam(std::string path, ::google::protobuf::Message& param)
{
    int fd = open(path.c_str(), O_RDONLY);
    if (fd == -1) return false;
    FileInputStream* input = new FileInputStream(fd);
    bool success = google::protobuf::TextFormat::Parse(input, &param);
    delete input;
    close(fd);
    return success;
}



Automatic::stCalibParam		m_laser_calib_param;
CProcess*					m_pProcess=0;

int main(int argc, char *argv[])
{
    QApplication a(argc, argv);
    MainWindow w;
    w.show();

    char buf[255]={0};
    getcwd(buf,255);
    sprintf(buf,"%s/setting/calib.prototxt",buf);

    if(!ReadProtoParam(buf,m_laser_calib_param))
    {
        QMessageBox::about(NULL, "Error", "Read proto failed...");
    }
    m_pProcess=new CProcess(m_laser_calib_param,&w);
    if(m_pProcess->Init()==false)
    {
        QMessageBox::about(NULL, "Error", m_pProcess->LastError().c_str());
    }

    return a.exec();
}
